<?php
class ControllerextensionModuleystep extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/ystep');

		$this->document->setTitle(preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')));

		$this->load->model('extension/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('ystep', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title'));

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_qq_open_signup'] = $this->language->get('text_qq_open_signup');

		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_titlename'] = $this->language->get('entry_titlename');
		$data['entry_bgcolortitle'] = $this->language->get('entry_bgcolortitle');
		$data['entry_bgcolor'] = $this->language->get('entry_bgcolor');
		$data['entry_bgcolorcss'] = $this->language->get('entry_bgcolorcss');
		$data['entry_titlejbcss'] = $this->language->get('entry_titlejbcss');
		$data['entry_titlejbsmcss'] = $this->language->get('entry_titlejbsmcss');
		$data['entry_titlecss'] = $this->language->get('entry_titlecss');
		$data['entry_titlesmcss'] = $this->language->get('entry_titlesmcss');
		$data['entry_describe'] = $this->language->get('entry_describe');
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_text'] = $this->language->get('entry_text');
		$data['entry_icon'] = $this->language->get('entry_icon');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_segmentingline'] = $this->language->get('entry_segmentingline');
		$data['entry_linew'] = $this->language->get('entry_linew');
		$data['entry_lineh'] = $this->language->get('entry_lineh');
        $data['entry_linec'] = $this->language->get('entry_linec');	
		$data['entry_sectionptop'] = $this->language->get('entry_sectionptop');
        $data['entry_sectionpbuttom'] = $this->language->get('entry_sectionpbuttom');
		
		$data['entry_step'] = $this->language->get('entry_step');
		$data['entry_stepcolumn'] = $this->language->get('entry_stepcolumn');
		$data['help_stepcolumn'] = $this->language->get('help_stepcolumn');
		$data['entry_stepborder'] = $this->language->get('entry_stepborder');
		$data['entry_stepbj'] = $this->language->get('entry_stepbj');
		$data['entry_stepwide'] = $this->language->get('entry_stepwide');
		$data['entry_stephigh'] = $this->language->get('entry_stephigh');
        $data['entry_stepline'] = $this->language->get('entry_stepline');	
		$data['entry_slborder'] = $this->language->get('entry_slborder');
        $data['entry_slcolor'] = $this->language->get('entry_slcolor');
		$data['entry_stepcolor'] = $this->language->get('entry_stepcolor');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_remove'] = $this->language->get('button_remove');

		$data['error_name'] = $this->language->get('error_name');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}
		if (isset($this->error['image'])) {
			$data['error_image'] = $this->error['image'];
		} else {
			$data['error_image'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}
		if (isset($this->error['stepcolumn'])) {
			$data['error_stepcolumn'] = $this->error['stepcolumn'];
		} else {
			$data['error_stepcolumn'] = '';
		}
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')),
			'href' => $this->url->link('extension/module/ystep', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/ystep', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('extension/module/ystep', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		$data['token'] = $this->session->data['token'];

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		$this->load->model('tool/image');

		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (isset($module_info['image'])) {
			$data['image'] = $module_info['image'];
		} else {
			$data['image'] = '';
		}

		if (is_file(DIR_IMAGE . $data['image'])) {
			$thumb = $data['image'];
		} else {
			$thumb = 'no_image.png';
		}

		$data['thumb'] = $this->model_tool_image->resize($thumb, 100, 100);

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = '1600';
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = '750';
		}
		if (isset($this->request->post['titlename'])) {
			$data['titlename'] = $this->request->post['titlename'];
		} elseif (!empty($module_info)) {
			$data['titlename'] = $module_info['titlename'];
		} else {
			$data['titlename'] = '';
		}
		if (isset($this->request->post['linew'])) {
			$data['linew'] = $this->request->post['linew'];
		} elseif (!empty($module_info)) {
			$data['linew'] = $module_info['linew'];
		} else {
			$data['linew'] = '30';
		}	
		if (isset($this->request->post['lineh'])) {
			$data['lineh'] = $this->request->post['lineh'];
		} elseif (!empty($module_info)) {
			$data['lineh'] = $module_info['lineh'];
		} else {
			$data['lineh'] = '2';
		}
		if (isset($this->request->post['linec'])) {
			$data['linec'] = $this->request->post['linec'];
		} elseif (!empty($module_info)) {
			$data['linec'] = $module_info['linec'];
		} else {
			$data['linec'] = '#000000';
		}
		if (isset($this->request->post['bgcolor'])) {
			$data['bgcolor'] = $this->request->post['bgcolor'];
		} elseif (!empty($module_info)) {
			$data['bgcolor'] = $module_info['bgcolor'];
		} else {
			$data['bgcolor'] = '';
		}
		if (isset($this->request->post['bgcolorcss'])) {
			$data['bgcolorcss'] = $this->request->post['bgcolorcss'];
		} elseif (!empty($module_info)) {
			$data['bgcolorcss'] = $module_info['bgcolorcss'];
		} else {
			$data['bgcolorcss'] = '';
		}
		if (isset($this->request->post['titlecss'])) {
			$data['titlecss'] = $this->request->post['titlecss'];
		} elseif (!empty($module_info)) {
			$data['titlecss'] = $module_info['titlecss'];
		} else {
			$data['titlecss'] = '';
		}		
		if (isset($this->request->post['titlesmcss'])) {
			$data['titlesmcss'] = $this->request->post['titlesmcss'];
		} elseif (!empty($module_info)) {
			$data['titlesmcss'] = $module_info['titlesmcss'];
		} else {
			$data['titlesmcss'] = '';
		}
		if (isset($this->request->post['describe'])) {
			$data['describe'] = $this->request->post['describe'];
		} elseif (!empty($module_info)) {
			$data['describe'] = $module_info['describe'];
		} else {
			$data['describe'] = '';
		}
		if (isset($this->request->post['stepcolumn'])) {
			$data['stepcolumn'] = $this->request->post['stepcolumn'];
		} elseif (!empty($module_info)) {
			$data['stepcolumn'] = $module_info['stepcolumn'];
		} else {
			$data['stepcolumn'] = '3';
		}
		if (isset($this->request->post['sectionptop'])) {
			$data['sectionptop'] = $this->request->post['sectionptop'];
		} elseif (!empty($module_info)) {
			$data['sectionptop'] = $module_info['sectionptop'];
		} else {
			$data['sectionptop'] = '70';
		}
		if (isset($this->request->post['sectionpbuttom'])) {
			$data['sectionpbuttom'] = $this->request->post['sectionpbuttom'];
		} elseif (!empty($module_info)) {
			$data['sectionpbuttom'] = $module_info['sectionpbuttom'];
		} else {
			$data['sectionpbuttom'] = '70';
		}
		if (isset($this->request->post['stepborder'])) {
			$data['stepborder'] = $this->request->post['stepborder'];
		} elseif (!empty($module_info)) {
			$data['stepborder'] = $module_info['stepborder'];
		} else {
			$data['stepborder'] = '';
		}
		if (isset($this->request->post['stepbj'])) {
			$data['stepbj'] = $this->request->post['stepbj'];
		} elseif (!empty($module_info)) {
			$data['stepbj'] = $module_info['stepbj'];
		} else {
			$data['stepbj'] = '';
		}
		if (isset($this->request->post['stepcolor'])) {
			$data['stepcolor'] = $this->request->post['stepcolor'];
		} elseif (!empty($module_info)) {
			$data['stepcolor'] = $module_info['stepcolor'];
		} else {
			$data['stepcolor'] = '';
		}
		if (isset($this->request->post['stepwide'])) {
			$data['stepwide'] = $this->request->post['stepwide'];
		} elseif (!empty($module_info)) {
			$data['stepwide'] = $module_info['stepwide'];
		} else {
			$data['stepwide'] = '30';
		}
		if (isset($this->request->post['stephigh'])) {
			$data['stephigh'] = $this->request->post['stephigh'];
		} elseif (!empty($module_info)) {
			$data['stephigh'] = $module_info['stephigh'];
		} else {
			$data['stephigh'] = '30';
		}	
		if (isset($this->request->post['slborder'])) {
			$data['slborder'] = $this->request->post['slborder'];
		} elseif (!empty($module_info)) {
			$data['slborder'] = $module_info['slborder'];
		} else {
			$data['slborder'] = '1';
		}
		if (isset($this->request->post['slcolor'])) {
			$data['slcolor'] = $this->request->post['slcolor'];
		} elseif (!empty($module_info)) {
			$data['slcolor'] = $module_info['slcolor'];
		} else {
			$data['slcolor'] = '#f2f2f2';
		}		
		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		$this->load->model('tool/image');

		if (isset($this->request->post['service'])) {
			$services = $this->request->post['service'];
		} elseif (isset($module_info['service'])) {
			$services = $module_info['service'];
		} else {
			$services = array();
		}

		$data['services'] = array();

		foreach ($services as $service) {

			$data['services'][] = array(
				'title'       => $service['title'],
				'text'        => $service['text'],
				'sort_order'  => $service['sort_order']
			);
		}

		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 30, 30);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/ystep.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/ystep')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 2) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}
		if (!$this->request->post['image']) {
			$this->error['image'] = $this->language->get('error_image');
		}

		if (!$this->request->post['width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['height']) {
			$this->error['height'] = $this->language->get('error_height');
		}
		if ((utf8_strlen($this->request->post['stepcolumn']) < 1) || (utf8_strlen($this->request->post['stepcolumn']) > 64)) {
			$this->error['stepcolumn'] = $this->language->get('error_stepcolumn');
		}
		return !$this->error;
	}
}